﻿using System;
using System.Collections.Generic;

namespace ShoppingCart.Web
{
   public class ShoppingModel
   {
      IDeposit m_deposit;
      IList<Product> m_products;
      ICart m_cart;
      [NonSerialized]
      IShoppingView m_view;

      public ShoppingModel( IDeposit deposit, ICart cart )
      {
         m_deposit = deposit;
         m_cart = cart;
         m_products = new List<Product>();
      }

      public void SetView( IShoppingView view )
      {
         m_view = view;
      }

      public void Fill()
      {
         m_products = m_deposit.Load();
      }

      public void Render()
      {
         foreach( Product product in m_products )
         {
            m_view.AddSourceItem( product.Name, m_cart.IsOkToAdd( product ) );
         }
         foreach( Product product in m_cart.List )
         {
            m_view.AddCartItem( product.Name );
         }
      }

      public void AddAt( int index )
      {
         var product = m_products[index];
         m_cart.Add( product );
      }
   }
}
